<?php
#===============================================================#
# PHP RSS Reader v.1.1 Copyright © By Richard James Kendall     #
# Bugs to richard@richardjameskendall.com                       #
# Free to use, please acknowledge me                            #
#===============================================================#
# A71-Rss v.1.6 • 01.01.2019 • By Alessandro Marinuzzi [Alecos] #
# Copyright © 2007-2019 By Alessandro Marinuzzi [Alecos]        #
# Email:  alecos@alecos.it                                      #
# Web:    https://www.alecos.it/                                #
# Status: Donationware License                                  #
#===============================================================#
@ini_set('default_charset', 'UTF-8');
set_time_limit(0);
#===============================================================#
#=========> Replace the XML url in $file within the ""; <=======#
#===============================================================#
$file = "https://newsrss.bbc.co.uk/rss/newsonline_uk_edition/world/rss.xml";
#===============================================================#
#================> Do not touch the code below <================#
#===============================================================#
$rss_channel = array();
$currently_writing = "";
$main = "";
$item_counter = 0;

function startElement($parser, $name, $attrs) {
  global $rss_channel, $currently_writing, $main;
  switch($name) {
    case "RSS":
    case "RDF:RDF":
    case "ITEMS":
      $currently_writing = "";
      break;
    case "CHANNEL":
      $main = "CHANNEL";
      break;
    case "IMAGE":
      $main = "IMAGE";
      $rss_channel["IMAGE"] = array();
      break;
    case "ITEM":
      $main = "ITEMS";
      break;
    default:
      $currently_writing = $name;
      break;
  }
}

function endElement($parser, $name) {
  global $rss_channel, $currently_writing, $item_counter;
  $currently_writing = "";
  if ($name == "ITEM") {
    $item_counter++;
  }
}

function characterData($parser, $data) {
  global $rss_channel, $currently_writing, $main, $item_counter;
  if ($currently_writing != "") {
    switch($main) {
      case "CHANNEL":
        if (isset($rss_channel[$currently_writing])) {
          $rss_channel[$currently_writing] .= $data;
        } else {
          $rss_channel[$currently_writing] = $data;
        }
        break;
      case "IMAGE":
        if (isset($rss_channel[$main][$currently_writing])) {
          $rss_channel[$main][$currently_writing] .= $data;
        } else {
          $rss_channel[$main][$currently_writing] = $data;
        }
        break;
      case "ITEMS":
        if (isset($rss_channel[$main][$item_counter][$currently_writing])) {
          $rss_channel[$main][$item_counter][$currently_writing] .= $data;
        } else {
          $rss_channel[$main][$item_counter][$currently_writing] = $data;
        }
        break;
    }
  }
}

$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");
if (!($fp = fopen($file, "r"))) {
  die("could not open XML input");
}
while ($data = fread($fp, 4096)) {
  if (!xml_parse($xml_parser, $data, feof($fp))) {
    die(sprintf("XML error: %s at line %d", xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
  }
}
xml_parser_free($xml_parser);
if (isset($rss_channel["ITEMS"])) {
  if (count($rss_channel["ITEMS"]) > 0) {
    $news = htmlspecialchars($rss_channel["TITLE"], ENT_QUOTES | ENT_HTML401, 'UTF-8');
    for($i = 0; $i < count($rss_channel["ITEMS"]); $i++) {
      $news .= "&nbsp;<span style='background-color: #ff4500; color: #f8f8ff; font: bold 12px arial; border: 1px solid #000000'>&nbsp;NEWS&nbsp;</span>&nbsp;<a style='text-decoration: none; color: #f8f8ff; font: 12px arial' href=\"" . str_replace(' ', '%20', $rss_channel["ITEMS"][$i]["LINK"]) . "\" target=\"_blank\">" . $rss_channel["ITEMS"][$i]["TITLE"] = htmlspecialchars($rss_channel["ITEMS"][$i]["TITLE"], ENT_QUOTES | ENT_HTML401, 'UTF-8') . "</a>";
    }
  } else {
    $news = "<span style='font-weight: bold'>There are no articles in this feed.</span>";
  }
}
print ("<span style='background-color: #483d8b; color: #f8f8ff; font: 12px arial; border: 1px solid #000000'>" . $news . "</span>");
?>